diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 6706e3f2a..8b159ac28 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -1369,9 +1181,9 @@ public class RenderGlobal
                             t.addVertex(x + oMax, y + oMax, z + oMin);
 
                             if (sTop.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM)) {
-                                t.setColorRGBA_F(0f, 1f, 0.5f, 0.25f);
+                                t.setColor4f(0f, 1f, 0.5f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 0.5f, 0.25f);
+                                t.setColor4f(1f, 0f, 0.5f, 0.25f);
                             }
                             t.addVertex(x + oMin, y + oMax, z + oMax);
                             t.addVertex(x + oMax, y + oMax, z + oMax);
@@ -1379,9 +1191,9 @@ public class RenderGlobal
                             t.addVertex(x + oMin + 0.25, y + oMax, z + oMax - 0.25);
 
                             if (sTop.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM)) {
-                                t.setColorRGBA_F(0f, 1f, 1f, 0.25f);
+                                t.setColor4f(0f, 1f, 1f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 1f, 0.25f);
+                                t.setColor4f(1f, 0f, 1f, 0.25f);
                             }
                             t.addVertex(x + oMin, y + oMax, z + oMin);
                             t.addVertex(x + oMin, y + oMax, z + oMax);
@@ -1389,9 +1201,9 @@ public class RenderGlobal
                             t.addVertex(x + oMin + 0.25, y + oMax, z + oMin + 0.25);
 
                             if (sTop.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM)) {
-                                t.setColorRGBA_F(0f, 1f, 1f, 0.25f);
+                                t.setColor4f(0f, 1f, 1f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 1f, 0.25f);
+                                t.setColor4f(1f, 0f, 1f, 0.25f);
                             }
                             t.addVertex(x + oMax, y + oMax, z + oMin);
                             t.addVertex(x + oMax - 0.25, y + oMax, z + oMin + 0.25);
@@ -1401,9 +1213,9 @@ public class RenderGlobal
 
                         {// Bottom
                             if (sBottom.canSupport(PartialSupport.INSTANCE.center(), Side.TOP)) {
-                                t.setColorRGBA_F(0f, 1f, 0f, 0.25f);
+                                t.setColor4f(0f, 1f, 0f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 0f, 0.25f);
+                                t.setColor4f(1f, 0f, 0f, 0.25f);
                             }
                             t.addVertex(x + oMin + 0.25, y + oMin, z + oMin + 0.25);
                             t.addVertex(x + oMax - 0.25, y + oMin, z + oMin + 0.25);
@@ -1411,9 +1223,9 @@ public class RenderGlobal
                             t.addVertex(x + oMin + 0.25, y + oMin, z + oMax - 0.25);
 
                             if (sBottom.canSupport(PartialSupport.INSTANCE.up(), Side.TOP)) {
-                                t.setColorRGBA_F(0.5f, 1f, 0.5f, 0.25f);
+                                t.setColor4f(0.5f, 1f, 0.5f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 0.5f, 0.25f);
+                                t.setColor4f(1f, 0f, 0.5f, 0.25f);
                             }
                             t.addVertex(x + oMin + 0.25, y + oMin, z + oMax - 0.25);
                             t.addVertex(x + oMax - 0.25, y + oMin, z + oMax - 0.25);
@@ -1421,9 +1233,9 @@ public class RenderGlobal
                             t.addVertex(x + oMin, y + oMin, z + oMax);
 
                             if (sBottom.canSupport(PartialSupport.INSTANCE.down(), Side.TOP)) {
-                                t.setColorRGBA_F(0f, 1f, 0.5f, 0.25f);
+                                t.setColor4f(0f, 1f, 0.5f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 0.5f, 0.25f);
+                                t.setColor4f(1f, 0f, 0.5f, 0.25f);
                             }
                             t.addVertex(x + oMin + 0.25, y + oMin, z + oMin + 0.25);
                             t.addVertex(x + oMin, y + oMin, z + oMin);
@@ -1431,9 +1243,9 @@ public class RenderGlobal
                             t.addVertex(x + oMax - 0.25, y + oMin, z + oMin + 0.25);
 
                             if (sBottom.canSupport(PartialSupport.INSTANCE.left(), Side.TOP)) {
-                                t.setColorRGBA_F(0f, 1f, 1f, 0.25f);
+                                t.setColor4f(0f, 1f, 1f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 1f, 0.25f);
+                                t.setColor4f(1f, 0f, 1f, 0.25f);
                             }
                             t.addVertex(x + oMax, y + oMin, z + oMin);
                             t.addVertex(x + oMax, y + oMin, z + oMax);
@@ -1441,9 +1253,9 @@ public class RenderGlobal
                             t.addVertex(x + oMax - 0.25, y + oMin, z + oMin + 0.25);
 
                             if (sBottom.canSupport(PartialSupport.INSTANCE.right(), Side.TOP)) {
-                                t.setColorRGBA_F(0f, 1f, 1f, 0.25f);
+                                t.setColor4f(0f, 1f, 1f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 1f, 0.25f);
+                                t.setColor4f(1f, 0f, 1f, 0.25f);
                             }
                             t.addVertex(x + oMin, y + oMin, z + oMin);
                             t.addVertex(x + oMin + 0.25, y + oMin, z + oMin + 0.25);
@@ -1453,9 +1265,9 @@ public class RenderGlobal
 
                         {// North
                             if (sNorth.canSupport(PartialSupport.INSTANCE.center(), Side.SOUTH)) {
-                                t.setColorRGBA_F(0f, 1f, 0f, 0.25f);
+                                t.setColor4f(0f, 1f, 0f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 0f, 0.25f);
+                                t.setColor4f(1f, 0f, 0f, 0.25f);
                             }
                             t.addVertex(x + oMin + 0.25, y + oMax - 0.25, z + oMin);
                             t.addVertex(x + oMax - 0.25, y + oMax - 0.25, z + oMin);
@@ -1463,9 +1275,9 @@ public class RenderGlobal
                             t.addVertex(x + oMin + 0.25, y + oMin + 0.25, z + oMin);
 
                             if (sNorth.canSupport(PartialSupport.INSTANCE.up(), Side.SOUTH)) {
-                                t.setColorRGBA_F(0f, 1f, 0.5f, 0.25f);
+                                t.setColor4f(0f, 1f, 0.5f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 0.5f, 0.25f);
+                                t.setColor4f(1f, 0f, 0.5f, 0.25f);
                             }
                             t.addVertex(x + oMin, y + oMax, z + oMin);
                             t.addVertex(x + oMax, y + oMax, z + oMin);
@@ -1473,9 +1285,9 @@ public class RenderGlobal
                             t.addVertex(x + oMin + 0.25, y + oMax - 0.25, z + oMin);
 
                             if (sNorth.canSupport(PartialSupport.INSTANCE.down(), Side.SOUTH)) {
-                                t.setColorRGBA_F(0f, 1f, 0.5f, 0.25f);
+                                t.setColor4f(0f, 1f, 0.5f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 0.5f, 0.25f);
+                                t.setColor4f(1f, 0f, 0.5f, 0.25f);
                             }
                             t.addVertex(x + oMin + 0.25, y + oMin + 0.25, z + oMin);
                             t.addVertex(x + oMax - 0.25, y + oMin + 0.25, z + oMin);
@@ -1483,9 +1295,9 @@ public class RenderGlobal
                             t.addVertex(x + oMin, y + oMin, z + oMin);
 
                             if (sNorth.canSupport(PartialSupport.INSTANCE.right(), Side.SOUTH)) {
-                                t.setColorRGBA_F(0f, 1f, 1f, 0.25f);
+                                t.setColor4f(0f, 1f, 1f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 1f, 0.25f);
+                                t.setColor4f(1f, 0f, 1f, 0.25f);
                             }
                             t.addVertex(x + oMin, y + oMax, z + oMin);
                             t.addVertex(x + oMin + 0.25, y + oMax - 0.25, z + oMin);
@@ -1493,9 +1305,9 @@ public class RenderGlobal
                             t.addVertex(x + oMin, y + oMin, z + oMin);
 
                             if (sNorth.canSupport(PartialSupport.INSTANCE.left(), Side.SOUTH)) {
-                                t.setColorRGBA_F(0f, 1f, 1f, 0.25f);
+                                t.setColor4f(0f, 1f, 1f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 1f, 0.25f);
+                                t.setColor4f(1f, 0f, 1f, 0.25f);
                             }
                             t.addVertex(x + oMax, y + oMax, z + oMin);
                             t.addVertex(x + oMax, y + oMin, z + oMin);
@@ -1505,9 +1317,9 @@ public class RenderGlobal
 
                         {// South
                             if (sSouth.canSupport(PartialSupport.INSTANCE.center(), Side.NORTH)) {
-                                t.setColorRGBA_F(0f, 1f, 0f, 0.25f);
+                                t.setColor4f(0f, 1f, 0f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 0f, 0.25f);
+                                t.setColor4f(1f, 0f, 0f, 0.25f);
                             }
                             t.addVertex(x + oMin + 0.25, y + oMax - 0.25, z + oMax);
                             t.addVertex(x + oMin + 0.25, y + oMin + 0.25, z + oMax);
@@ -1515,9 +1327,9 @@ public class RenderGlobal
                             t.addVertex(x + oMax - 0.25, y + oMax - 0.25, z + oMax);
 
                             if (sSouth.canSupport(PartialSupport.INSTANCE.up(), Side.NORTH)) {
-                                t.setColorRGBA_F(0f, 1f, 0.5f, 0.25f);
+                                t.setColor4f(0f, 1f, 0.5f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 0.5f, 0.25f);
+                                t.setColor4f(1f, 0f, 0.5f, 0.25f);
                             }
                             t.addVertex(x + oMin, y + oMax, z + oMax);
                             t.addVertex(x + oMin + 0.25, y + oMax - 0.25, z + oMax);
@@ -1525,9 +1337,9 @@ public class RenderGlobal
                             t.addVertex(x + oMax, y + oMax, z + oMax);
 
                             if (sSouth.canSupport(PartialSupport.INSTANCE.down(), Side.NORTH)) {
-                                t.setColorRGBA_F(0f, 1f, 0.5f, 0.25f);
+                                t.setColor4f(0f, 1f, 0.5f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 0.5f, 0.25f);
+                                t.setColor4f(1f, 0f, 0.5f, 0.25f);
                             }
                             t.addVertex(x + oMin + 0.25, y + oMin + 0.25, z + oMax);
                             t.addVertex(x + oMin, y + oMin, z + oMax);
@@ -1535,9 +1347,9 @@ public class RenderGlobal
                             t.addVertex(x + oMax - 0.25, y + oMin + 0.25, z + oMax);
 
                             if (sSouth.canSupport(PartialSupport.INSTANCE.right(), Side.NORTH)) {
-                                t.setColorRGBA_F(0f, 1f, 1f, 0.25f);
+                                t.setColor4f(0f, 1f, 1f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 1f, 0.25f);
+                                t.setColor4f(1f, 0f, 1f, 0.25f);
                             }
                             t.addVertex(x + oMax, y + oMax, z + oMax);
                             t.addVertex(x + oMax - 0.25, y + oMax - 0.25, z + oMax);
@@ -1545,9 +1357,9 @@ public class RenderGlobal
                             t.addVertex(x + oMax, y + oMin, z + oMax);
 
                             if (sSouth.canSupport(PartialSupport.INSTANCE.left(), Side.NORTH)) {
-                                t.setColorRGBA_F(0f, 1f, 1f, 0.25f);
+                                t.setColor4f(0f, 1f, 1f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 1f, 0.25f);
+                                t.setColor4f(1f, 0f, 1f, 0.25f);
                             }
                             t.addVertex(x + oMin, y + oMax, z + oMax);
                             t.addVertex(x + oMin, y + oMin, z + oMax);
@@ -1557,9 +1369,9 @@ public class RenderGlobal
 
                         {// West
                             if (sWest.canSupport(PartialSupport.INSTANCE.center(), Side.EAST)) {
-                                t.setColorRGBA_F(0f, 1f, 0f, 0.25f);
+                                t.setColor4f(0f, 1f, 0f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 0f, 0.25f);
+                                t.setColor4f(1f, 0f, 0f, 0.25f);
                             }
                             t.addVertex(x + oMin, y + oMax - 0.25, z + oMin + 0.25);
                             t.addVertex(x + oMin, y + oMin + 0.25, z + oMin + 0.25);
@@ -1567,9 +1379,9 @@ public class RenderGlobal
                             t.addVertex(x + oMin, y + oMax - 0.25, z + oMax - 0.25);
 
                             if (sWest.canSupport(PartialSupport.INSTANCE.up(), Side.EAST)) {
-                                t.setColorRGBA_F(0f, 1f, 0.5f, 0.25f);
+                                t.setColor4f(0f, 1f, 0.5f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 0.5f, 0.25f);
+                                t.setColor4f(1f, 0f, 0.5f, 0.25f);
                             }
                             t.addVertex(x + oMin, y + oMax, z + oMin);
                             t.addVertex(x + oMin, y + oMax - 0.25, z + oMin + 0.25);
@@ -1577,9 +1389,9 @@ public class RenderGlobal
                             t.addVertex(x + oMin, y + oMax, z + oMax);
 
                             if (sWest.canSupport(PartialSupport.INSTANCE.down(), Side.EAST)) {
-                                t.setColorRGBA_F(0f, 1f, 0.5f, 0.25f);
+                                t.setColor4f(0f, 1f, 0.5f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 0.5f, 0.25f);
+                                t.setColor4f(1f, 0f, 0.5f, 0.25f);
                             }
                             t.addVertex(x + oMin, y + oMin, z + oMin);
                             t.addVertex(x + oMin, y + oMin, z + oMax);
@@ -1587,9 +1399,9 @@ public class RenderGlobal
                             t.addVertex(x + oMin, y + oMin + 0.25, z + oMin + 0.25);
 
                             if (sWest.canSupport(PartialSupport.INSTANCE.left(), Side.EAST)) {
-                                t.setColorRGBA_F(0f, 1f, 1f, 0.25f);
+                                t.setColor4f(0f, 1f, 1f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 1f, 0.25f);
+                                t.setColor4f(1f, 0f, 1f, 0.25f);
                             }
                             t.addVertex(x + oMin, y + oMax, z + oMin);
                             t.addVertex(x + oMin, y + oMin, z + oMin);
@@ -1597,9 +1409,9 @@ public class RenderGlobal
                             t.addVertex(x + oMin, y + oMax - 0.25, z + oMin + 0.25);
 
                             if (sWest.canSupport(PartialSupport.INSTANCE.right(), Side.EAST)) {
-                                t.setColorRGBA_F(0f, 1f, 1f, 0.25f);
+                                t.setColor4f(0f, 1f, 1f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 1f, 0.25f);
+                                t.setColor4f(1f, 0f, 1f, 0.25f);
                             }
                             t.addVertex(x + oMin, y + oMax - 0.25, z + oMax - 0.25);
                             t.addVertex(x + oMin, y + oMin + 0.25, z + oMax - 0.25);
@@ -1609,9 +1421,9 @@ public class RenderGlobal
 
                         {// East
                             if (sEast.canSupport(PartialSupport.INSTANCE.center(), Side.WEST)) {
-                                t.setColorRGBA_F(0f, 1f, 0f, 0.25f);
+                                t.setColor4f(0f, 1f, 0f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 0f, 0.25f);
+                                t.setColor4f(1f, 0f, 0f, 0.25f);
                             }
                             t.addVertex(x + oMax, y + oMax - 0.25, z + oMin + 0.25);
                             t.addVertex(x + oMax, y + oMax - 0.25, z + oMax - 0.25);
@@ -1619,9 +1431,9 @@ public class RenderGlobal
                             t.addVertex(x + oMax, y + oMin + 0.25, z + oMin + 0.25);
 
                             if (sEast.canSupport(PartialSupport.INSTANCE.up(), Side.WEST)) {
-                                t.setColorRGBA_F(0f, 1f, 0.5f, 0.25f);
+                                t.setColor4f(0f, 1f, 0.5f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 0.5f, 0.25f);
+                                t.setColor4f(1f, 0f, 0.5f, 0.25f);
                             }
                             t.addVertex(x + oMax, y + oMax, z + oMin);
                             t.addVertex(x + oMax, y + oMax, z + oMax);
@@ -1629,9 +1441,9 @@ public class RenderGlobal
                             t.addVertex(x + oMax, y + oMax - 0.25, z + oMin + 0.25);
 
                             if (sEast.canSupport(PartialSupport.INSTANCE.down(), Side.WEST)) {
-                                t.setColorRGBA_F(0f, 1f, 0.5f, 0.25f);
+                                t.setColor4f(0f, 1f, 0.5f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 0.5f, 0.25f);
+                                t.setColor4f(1f, 0f, 0.5f, 0.25f);
                             }
                             t.addVertex(x + oMax, y + oMin, z + oMin);
                             t.addVertex(x + oMax, y + oMin + 0.25, z + oMin + 0.25);
@@ -1639,9 +1451,9 @@ public class RenderGlobal
                             t.addVertex(x + oMax, y + oMin, z + oMax);
 
                             if (sEast.canSupport(PartialSupport.INSTANCE.left(), Side.WEST)) {
-                                t.setColorRGBA_F(0f, 1f, 1f, 0.25f);
+                                t.setColor4f(0f, 1f, 1f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 1f, 0.25f);
+                                t.setColor4f(1f, 0f, 1f, 0.25f);
                             }
                             t.addVertex(x + oMax, y + oMax - 0.25, z + oMax - 0.25);
                             t.addVertex(x + oMax, y + oMax, z + oMax);
@@ -1649,9 +1461,9 @@ public class RenderGlobal
                             t.addVertex(x + oMax, y + oMin + 0.25, z + oMax - 0.25);
 
                             if (sEast.canSupport(PartialSupport.INSTANCE.right(), Side.WEST)) {
-                                t.setColorRGBA_F(0f, 1f, 1f, 0.25f);
+                                t.setColor4f(0f, 1f, 1f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 1f, 0.25f);
+                                t.setColor4f(1f, 0f, 1f, 0.25f);
                             }
                             t.addVertex(x + oMax, y + oMax, z + oMin);
                             t.addVertex(x + oMax, y + oMax - 0.25, z + oMin + 0.25);
@@ -1665,23 +1477,21 @@ public class RenderGlobal
             } else if (hitResult instanceof HitResult.Entity hitEntity && hitEntity.entity.showBoundingBoxOnHover() && !this.mc.gameSettings.showCollisionBoxes.value) {
                 drawInterpolatedEntityBoundingBox(hitEntity.entity, hitEntity.entity.bb, camera, partialTick);
             }
-
-            GL11.glDepthMask(true);
-            GL11.glEnable(GL11.GL_TEXTURE_2D);
-            GL11.glDisable(GL11.GL_BLEND);
+            GLRenderer.popFrame();
         }
     }
 
     public void drawDebugEntityOutlines(ICamera camera, float partialTicks) {
-        glDisable(GL_TEXTURE_2D);
-        glLineWidth(2.0f);
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.LINES);
+        GLRenderer.setLineWidth(2f);
 
         double offsetX = camera.getX(partialTicks);
         double offsetY = camera.getY(partialTicks);
         double offsetZ = camera.getZ(partialTicks);
         float expand = 0.002F;
         List<AABBdc> collidingBoundingBoxes = this.world.getCubes(this.mc.thePlayer, MathHelper.aabbGrow(this.mc.thePlayer.bb, expand, expand, expand, new AABBd()));
-        glColor4f(0.0f, 0.0f, 1.0f, 1.0f);
+        GLRenderer.setColor4f(0.0f, 0.0f, 1.0f, 1.0f);
         for (AABBdc aabb : collidingBoundingBoxes) {
             AABBd bb = aabb.translate(-offsetX, -offsetY, -offsetZ, new AABBd());
             MathHelper.aabbGrow(bb, expand, expand, expand, bb);
@@ -1694,45 +1504,43 @@ public class RenderGlobal
         }
         List<Entity> entitiesNearby = this.world.getEntitiesWithinAABBExcludingEntity(null, MathHelper.aabbGrow(this.mc.thePlayer.bb, entityRadius, entityRadius, entityRadius, new AABBd()));
         for (Entity e : entitiesNearby) {
-            glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
+            GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f);
             drawInterpolatedEntityBoundingBox(e, e.bb, camera, partialTicks); // Bounds
 
-            glColor4f(1.0f, 0.0f, 0.0f, 1.0f);
+            GLRenderer.setColor4f(1.0f, 0.0f, 0.0f, 1.0f);
             final AABBd head = new AABBd(e.bb);
             head.setMin(head.minX, e.y + e.getHeadHeight() - 0.005, head.minZ).setMax(head.maxX, e.y + e.getHeadHeight() + 0.005, head.maxZ);
             drawInterpolatedEntityBoundingBox(e, head, camera, partialTicks); // Head
 
-            glColor4f(1.0f, 0.0f, 1.0f, 1.0f);
+            GLRenderer.setColor4f(1.0f, 0.0f, 1.0f, 1.0f);
             final AABBd feet = new AABBd(e.bb.minX, e.y - 0.005, e.bb.minZ, e.bb.maxX, e.y + 0.005, e.bb.maxZ);
             drawInterpolatedEntityBoundingBox(e, feet, camera, partialTicks); // Feet
 
-            glColor4f(0.75f, 0.75f, 1.0f, 1.0f);
-            drawInterpolatedEntityBoundingBox(e, EntityRenderDispatcher.instance.getRenderer(e).entityViewBox(e), camera, partialTicks); // Model vis bounds
+            GLRenderer.setColor4f(0.75f, 0.75f, 1.0f, 1.0f);
+            drawInterpolatedEntityBoundingBox(e, EntityRendererDispatcher.instance.getRenderer(e).entityViewBox(e), camera, partialTicks); // Model vis bounds
 
             double lerpOffsetX = MathHelper.lerp(e.xo, e.x, partialTicks) - camera.getX(partialTicks);
             double lerpOffsetY = MathHelper.lerp(e.yo, e.y, partialTicks) - camera.getY(partialTicks);
             double lerpOffsetZ = MathHelper.lerp(e.zo, e.z, partialTicks) - camera.getZ(partialTicks);
-            drawDebugVec(Tessellator.instance, new Vector3d(lerpOffsetX, lerpOffsetY + e.getHeadHeight(), lerpOffsetZ), e.getViewVector(partialTicks), 1, 0, 1, 0, 1);
-            glDisable(GL_TEXTURE_2D);
-            GL11.glLineWidth(2);
+            drawDebugVec(GLRenderer.getTessellator(), new Vector3d(lerpOffsetX, lerpOffsetY + e.getHeadHeight(), lerpOffsetZ), e.getViewVector(partialTicks), 1, 0, 1, 0, 1);
         }
-
-        glEnable(GL_TEXTURE_2D);
+        GLRenderer.popFrame();
     }
 
-    public static void drawDebugVec(final @NotNull Tessellator tessellator, final @NotNull Vector3dc pos, final @Nullable Vector3dc vec, final double scale, final float r, final float g, final float b, final float a) {
+    public static void drawDebugVec(final @NotNull TessellatorGeneral tessellator, final @NotNull Vector3dc pos, final @Nullable Vector3dc vec, final double scale, final float r, final float g, final float b, final float a) {
         if (vec == null) return;
-        GL11.glLineWidth(10);
-        GL11.glDisable(GL11.GL_TEXTURE_2D);
-        tessellator.startDrawing(GL11.GL_LINES);
-        tessellator.setColorRGBA_F(r, g, b, a);
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.LINES);
+        GLRenderer.setLineWidth(10f);
+        tessellator.startDrawing(DrawMode.LINES);
+        tessellator.setColor4f(r, g, b, a);
         tessellator.addVertex(pos.x(), pos.y(), pos.z());
         tessellator.addVertex(
             pos.x() + vec.x() * scale,
             pos.y() + vec.y() * scale,
             pos.z() + vec.z() * scale);
         tessellator.draw();
-        GL11.glEnable(GL11.GL_TEXTURE_2D);
+        GLRenderer.popFrame();
     }
 
     public void drawInterpolatedEntityBoundingBox(@NotNull Entity entity, @NotNull AABBdc boundingBox, @NotNull ICamera camera, float partialTicks) {
@@ -1751,14 +1559,15 @@ public class RenderGlobal
     }
 
     public void drawDebugChunkBorders(@NotNull ICamera camera, float partialTicks) {
-        glDisable(GL_TEXTURE_2D);
-        glDisable(GL_FOG);
+//        glDisable(GL_FOG);
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.LINES);
 
         double offsetX = camera.getX(partialTicks);
         double offsetY = camera.getY(partialTicks);
         double offsetZ = camera.getZ(partialTicks);
 
-        Tessellator tessellator = Tessellator.instance;
+        TessellatorGeneral tessellator = GLRenderer.getTessellator();
         tessellator.setTranslation(-offsetX, -offsetY, -offsetZ);
 
         int blockX = MathHelper.floor(this.mc.thePlayer.x);
@@ -1775,9 +1584,9 @@ public class RenderGlobal
 
         int worldHeight = this.mc.currentWorld.getHeightBlocks();
 
-        glLineWidth(2.0f);
-        glColor4f(1.0f, 0.0f, 0.0f, 1.0f);
-        tessellator.startDrawing(GL_LINES);
+        GLRenderer.setLineWidth(2.0f);
+        GLRenderer.setColor4f(1.0f, 0.0f, 0.0f, 1.0f);
+        tessellator.startDrawing(DrawMode.LINES);
 
         // Draw vertical red lines
         for (int i = -1; i <= 2; i++) {
@@ -1792,9 +1601,9 @@ public class RenderGlobal
 
         tessellator.draw();
 
-        glLineWidth(1.0f);
-        glColor4f(0.0f, 1.0f, 0.0f, 1.0f);
-        tessellator.startDrawing(GL_LINES);
+        GLRenderer.setLineWidth(1.0f);
+        GLRenderer.setColor4f(0.0f, 1.0f, 0.0f, 1.0f);
+        tessellator.startDrawing(DrawMode.LINES);
 
         // Draw horizontal green lines
         for (int y = 0; y <= worldHeight; y++) {
@@ -1834,27 +1643,27 @@ public class RenderGlobal
         tessellator.draw();
 
         tessellator.setTranslation(0.0, 0.0, 0.0);
-        glEnable(GL_TEXTURE_2D);
-        glEnable(GL_FOG);
+        GLRenderer.popFrame();
+//        glEnable(GL_FOG);
     }
 
     public void drawOutlinedBoundingBox(@NotNull AABBdc aabb) {
-        Tessellator tessellator = Tessellator.instance;
-        tessellator.startDrawing(GL11.GL_LINE_STRIP);
+        TessellatorGeneral tessellator = GLRenderer.getTessellator();
+        tessellator.startDrawing(DrawMode.LINE_STRIP);
         tessellator.addVertex(aabb.minX(), aabb.minY(), aabb.minZ());
         tessellator.addVertex(aabb.maxX(), aabb.minY(), aabb.minZ());
         tessellator.addVertex(aabb.maxX(), aabb.minY(), aabb.maxZ());
         tessellator.addVertex(aabb.minX(), aabb.minY(), aabb.maxZ());
         tessellator.addVertex(aabb.minX(), aabb.minY(), aabb.minZ());
         tessellator.draw();
-        tessellator.startDrawing(GL11.GL_LINE_STRIP);
+        tessellator.startDrawing(DrawMode.LINE_STRIP);
         tessellator.addVertex(aabb.minX(), aabb.maxY(), aabb.minZ());
         tessellator.addVertex(aabb.maxX(), aabb.maxY(), aabb.minZ());
         tessellator.addVertex(aabb.maxX(), aabb.maxY(), aabb.maxZ());
         tessellator.addVertex(aabb.minX(), aabb.maxY(), aabb.maxZ());
         tessellator.addVertex(aabb.minX(), aabb.maxY(), aabb.minZ());
         tessellator.draw();
-        tessellator.startDrawing(GL11.GL_LINES);
+        tessellator.startDrawing(DrawMode.LINES);
         tessellator.addVertex(aabb.minX(), aabb.minY(), aabb.minZ());
         tessellator.addVertex(aabb.minX(), aabb.maxY(), aabb.minZ());
         tessellator.addVertex(aabb.maxX(), aabb.minY(), aabb.minZ());
@@ -1867,8 +1676,8 @@ public class RenderGlobal
     }
 
     public void drawOutlinedVolume(BoundingVolume volume, double xOffset, double yOffset, double zOffset, float expand) {
-        Tessellator t = Tessellator.instance;
-        t.startDrawing(GL11.GL_LINES);
+        TessellatorGeneral t = GLRenderer.getTessellator();
+        t.startDrawing(DrawMode.LINES);
         Float[] points = volume.getBakedLineCoords();
         for (int i = 0; i < points.length; i += 3) {
             float expand0 = ((points[i] - 0.5f) * 2) * expand;
@@ -1979,7 +1788,7 @@ public class RenderGlobal
         if (seasonChanged) {
             Colorizers.update(false);
         }
-        if (seasonChanged || lightChanged && !LightmapHelper.isLightmapEnabled()) {
+        if (seasonChanged) {
             for (ChunkRenderer chunkRenderer : this.chunkRenderers) {
                 if (chunkRenderer.skyLit && !chunkRenderer.dirty) {
                     this.dirtyChunks.add(chunkRenderer);
@@ -1993,12 +1802,6 @@ public class RenderGlobal
     public void tileEntityChanged(int x, int y, int z, TileEntity tileEntity) {
     }
 
-    public void deleteChunkLists() {
-        if (this.chunkLists >= 0) {
-            GLAllocation.deleteDisplayList(this.chunkLists);
-        }
-    }
-
     @Override
     public void levelEvent(@Nullable Player player, int id, int x, int y, int z, int data) {
         Random random = this.world.rand;
diff --git a/game/client/src/main/java/net/minecraft/client/render/Renderer.java b/game/client/src/main/java/net/minecraft/client/render/Renderer.java
index f53280117..9c6f20d14 100644
--- a/game/client/src/main/java/net/minecraft/client/render/Renderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/Renderer.java
@@ -1,8 +1,5 @@
 package net.minecraft.client.render;
 
-import net.minecraft.client.render.tessellator.ParticleTessellator;
-import org.jetbrains.annotations.NotNull;
-
 public interface Renderer {
 	
 	public void beginRenderGame(float partialTicks);
@@ -13,8 +10,6 @@ public interface Renderer {
 
 	public void beginRenderParticles(float partialTicks);
 
-	public @NotNull ParticleTessellator getParticleTessellator();
-
 	public void endRenderGame(float partialTicks);
 
 	public void endRenderWorld(float partialTicks);
